Index: src/Tesselation/tesselation.cpp
===================================================================
--- src/Tesselation/tesselation.cpp	(revision 2a3124b519027c588e363ec4c5a44171b4715777)
+++ src/Tesselation/tesselation.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
@@ -68,5 +68,5 @@
   InternalPointer(PointsOnBoundary.begin())
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
 }
 ;
@@ -77,6 +77,6 @@
 Tesselation::~Tesselation()
 {
-  Info FunctionInfo(__func__);
-  LOG(0, "Free'ing TesselStruct ... ");
+  //Info FunctionInfo(__func__);
+  LOG(2, "INFO: Free'ing TesselStruct ... ");
   for (TriangleMap::iterator runner = TrianglesOnBoundary.begin(); runner != TrianglesOnBoundary.end(); runner++) {
     if (runner->second != NULL) {
@@ -86,5 +86,5 @@
       ELOG(1, "The triangle " << runner->first << " has already been free'd.");
   }
-  LOG(0, "This envelope was written to file " << TriangleFilesWritten << " times(s).");
+  LOG(1, "INFO: This envelope was written to file " << TriangleFilesWritten << " times(s).");
 }
 
@@ -198,5 +198,5 @@
 void Tesselation::GuessStartingTriangle()
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   // 4b. create a starting triangle
   // 4b1. create all distances
@@ -331,5 +331,5 @@
 void Tesselation::TesselateOnBoundary(IPointCloud & cloud)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   bool flag;
   PointMap::iterator winner;
@@ -350,9 +350,9 @@
         // get peak point with respect to this base line's only triangle
         BTS = baseline->second->triangles.begin()->second; // there is only one triangle so far
-        LOG(0, "Current baseline is between " << *(baseline->second) << ".");
+        LOG(3, "DEBUG: Current baseline is between " << *(baseline->second) << ".");
         for (int i = 0; i < 3; i++)
           if ((BTS->endpoints[i] != baseline->second->endpoints[0]) && (BTS->endpoints[i] != baseline->second->endpoints[1]))
             peak = BTS->endpoints[i];
-        LOG(1, " and has peak " << *peak << ".");
+        LOG(3, "DEBUG:    and has peak " << *peak << ".");
 
         // prepare some auxiliary vectors
@@ -373,5 +373,5 @@
         BTS->GetNormalVector(NormalVector);
         NormalVector = BTS->NormalVector;
-        LOG(2, "NormalVector of base triangle is " << NormalVector);
+        LOG(4, "DEBUG: NormalVector of base triangle is " << NormalVector);
 
         // vector in propagation direction (out of triangle)
@@ -382,5 +382,5 @@
         if (PropagationVector.ScalarProduct(TempVector) > 0) // make sure normal propagation vector points outward from baseline
           PropagationVector.Scale(-1.);
-        LOG(2, "PropagationVector of base triangle is " << PropagationVector);
+        LOG(4, "DEBUG: PropagationVector of base triangle is " << PropagationVector);
         winner = PointsOnBoundary.end();
 
@@ -388,5 +388,5 @@
         for (PointMap::iterator target = PointsOnBoundary.begin(); target != PointsOnBoundary.end(); target++) {
           if ((target->second != baseline->second->endpoints[0]) && (target->second != baseline->second->endpoints[1])) { // don't take the same endpoints
-            LOG(1, "Target point is " << *(target->second) << ":");
+            LOG(4, "DEBUG: Target point is " << *(target->second) << ":");
 
             // first check direction, so that triangles don't intersect
@@ -394,10 +394,10 @@
             VirtualNormalVector.ProjectOntoPlane(NormalVector);
             TempAngle = VirtualNormalVector.Angle(PropagationVector);
-            LOG(2, "VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << ".");
+            LOG(5, "DEBUG: VirtualNormalVector is " << VirtualNormalVector << " and PropagationVector is " << PropagationVector << ".");
             if (TempAngle > (M_PI / 2.)) { // no bends bigger than Pi/2 (90 degrees)
-              LOG(2, "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!");
+              LOG(5, "DEBUG: Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", bad direction!");
               continue;
             } else
-              LOG(2, "Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!");
+              LOG(5, "DEBUG: Angle on triangle plane between propagation direction and base line to " << *(target->second) << " is " << TempAngle << ", good direction!");
 
             // check first and second endpoint (if any connecting line goes to target has at least not more than 1 triangle)
@@ -405,9 +405,9 @@
             LineChecker[1] = baseline->second->endpoints[1]->lines.find(target->first);
             if (((LineChecker[0] != baseline->second->endpoints[0]->lines.end()) && (LineChecker[0]->second->triangles.size() == 2))) {
-              LOG(2, *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles.");
+              LOG(5, "DEBUG: " << *(baseline->second->endpoints[0]) << " has line " << *(LineChecker[0]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[0]->second->triangles.size() << " triangles.");
               continue;
             }
             if (((LineChecker[1] != baseline->second->endpoints[1]->lines.end()) && (LineChecker[1]->second->triangles.size() == 2))) {
-              LOG(2, *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles.");
+              LOG(5, "DEBUG: " << *(baseline->second->endpoints[1]) << " has line " << *(LineChecker[1]->second) << " to " << *(target->second) << " as endpoint with " << LineChecker[1]->second->triangles.size() << " triangles.");
               continue;
             }
@@ -415,5 +415,5 @@
             // check whether the envisaged triangle does not already exist (if both lines exist and have same endpoint)
             if ((((LineChecker[0] != baseline->second->endpoints[0]->lines.end()) && (LineChecker[1] != baseline->second->endpoints[1]->lines.end()) && (GetCommonEndpoint(LineChecker[0]->second, LineChecker[1]->second) == peak)))) {
-              LOG(4, "Current target is peak!");
+              LOG(6, "DEBUG: Current target is peak!");
               continue;
             }
@@ -442,9 +442,9 @@
             // calculate angle
             TempAngle = NormalVector.Angle(VirtualNormalVector);
-            LOG(2, "NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << ".");
+            LOG(5, "DEBUG: NormalVector is " << VirtualNormalVector << " and the angle is " << TempAngle << ".");
             if ((SmallestAngle - TempAngle) > MYEPSILON) { // set to new possible winner
               SmallestAngle = TempAngle;
               winner = target;
-              LOG(2, "New winner " << *winner->second->node << " due to smaller angle between normal vectors.");
+              LOG(5, "DEBUG: New winner " << *winner->second->node << " due to smaller angle between normal vectors.");
             } else if (fabs(SmallestAngle - TempAngle) < MYEPSILON) { // check the angle to propagation, both possible targets are in one plane! (their normals have same angle)
               // hence, check the angles to some normal direction from our base line but in this common plane of both targets...
@@ -461,9 +461,9 @@
                 SmallestAngle = TempAngle;
                 winner = target;
-                LOG(2, "New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction.");
+                LOG(5, "DEBUG: New winner " << *winner->second->node << " due to smaller angle " << TempAngle << " to propagation direction.");
               } else
-                LOG(2, "Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction.");
+                LOG(5, "DEBUG: Keeping old winner " << *winner->second->node << " due to smaller angle to propagation direction.");
             } else
-              LOG(2, "Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors.");
+              LOG(5, "DEBUG: Keeping old winner " << *winner->second->node << " due to smaller angle between normal vectors.");
           }
         } // end of loop over all boundary points
@@ -471,5 +471,5 @@
         // 5b. The point of the above whose triangle has the greatest angle with the triangle the current line belongs to (it only belongs to one, remember!): New triangle
         if (winner != PointsOnBoundary.end()) {
-          LOG(0, "Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << ".");
+          LOG(3, "DEBUG: Winning target point is " << *(winner->second) << " with angle " << SmallestAngle << ".");
           // create the lins of not yet present
           BLS[0] = baseline->second;
@@ -506,5 +506,5 @@
         // 5d. If the set of lines is not yet empty, go to 5. and continue
       } else
-        LOG(0, "Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << ".");
+        LOG(3, "DEBUG: Baseline candidate " << *(baseline->second) << " has a triangle count of " << baseline->second->triangles.size() << ".");
   } while (flag);
 
@@ -522,5 +522,5 @@
 bool Tesselation::InsertStraddlingPoints(IPointCloud & cloud, const LinkedCell_deprecated *LC)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   Vector Intersection, Normal;
   TesselPoint *Walker = NULL;
@@ -541,5 +541,5 @@
     }
     Walker = cloud.GetPoint();
-    LOG(0, "Current point is " << *Walker << ".");
+    LOG(3, "DEBUG: Current point is " << *Walker << ".");
     // get the next triangle
     triangles = FindClosestTrianglesToVector(Walker->getPosition(), BoundaryPoints);
@@ -550,20 +550,20 @@
     delete triangles;
     if ((BTS == NULL) || (BTS->ContainsBoundaryPoint(Walker))) {
-      LOG(0, "No triangles found, probably a tesselation point itself.");
+      LOG(3, "DEBUG: No triangles found, probably a tesselation point itself.");
       cloud.GoToNext();
       continue;
     } else {
     }
-    LOG(0, "Closest triangle is " << *BTS << ".");
+    LOG(3, "DEBUG: Closest triangle is " << *BTS << ".");
     // get the intersection point
     if (BTS->GetIntersectionInsideTriangle(*Center, Walker->getPosition(), Intersection)) {
-      LOG(0, "We have an intersection at " << Intersection << ".");
+      LOG(3, "DEBUG: We have an intersection at " << Intersection << ".");
       // we have the intersection, check whether in- or outside of boundary
       if ((Center->DistanceSquared(Walker->getPosition()) - Center->DistanceSquared(Intersection)) < -MYEPSILON) {
         // inside, next!
-        LOG(0, *Walker << " is inside wrt triangle " << *BTS << ".");
+        LOG(3, "DEBUG: " << *Walker << " is inside wrt triangle " << *BTS << ".");
       } else {
         // outside!
-        LOG(0, *Walker << " is outside wrt triangle " << *BTS << ".");
+        LOG(3, "DEBUG: " << *Walker << " is outside wrt triangle " << *BTS << ".");
         class BoundaryLineSet *OldLines[3], *NewLines[3];
         class BoundaryPointSet *OldPoints[3], *NewPoint;
@@ -575,5 +575,5 @@
         Normal = BTS->NormalVector;
         // add Walker to boundary points
-        LOG(0, "Adding " << *Walker << " to BoundaryPoints.");
+        LOG(3, "DEBUG: Adding " << *Walker << " to BoundaryPoints.");
         AddFlag = true;
         if (AddBoundaryPoint(Walker, 0))
@@ -582,5 +582,5 @@
           continue;
         // remove triangle
-        LOG(0, "Erasing triangle " << *BTS << ".");
+        LOG(3, "DEBUG: Erasing triangle " << *BTS << ".");
         TrianglesOnBoundary.erase(BTS->Nr);
         delete (BTS);
@@ -590,5 +590,5 @@
           BPS[1] = OldPoints[i];
           NewLines[i] = new class BoundaryLineSet(BPS, LinesOnBoundaryCount);
-          LOG(1, "Creating new line " << *NewLines[i] << ".");
+          LOG(4, "DEBUG: Creating new line " << *NewLines[i] << ".");
           LinesOnBoundary.insert(LinePair(LinesOnBoundaryCount, NewLines[i])); // no need for check for unique insertion as BPS[0] is definitely a new one
           LinesOnBoundaryCount++;
@@ -612,5 +612,5 @@
           BTS->GetNormalVector(Normal);
           Normal.Scale(-1.);
-          LOG(0, "Created new triangle " << *BTS << ".");
+          LOG(3, "DEBUG: Created new triangle " << *BTS << ".");
           TrianglesOnBoundary.insert(TrianglePair(TrianglesOnBoundaryCount, BTS));
           TrianglesOnBoundaryCount++;
@@ -639,5 +639,5 @@
 bool Tesselation::AddBoundaryPoint(TesselPoint * Walker, const int n)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   PointTestPair InsertUnique;
   BPS[n] = new class BoundaryPointSet(Walker);
@@ -661,5 +661,5 @@
 void Tesselation::AddTesselationPoint(TesselPoint* Candidate, const int n)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   PointTestPair InsertUnique;
   TPS[n] = new class BoundaryPointSet(Candidate);
@@ -669,5 +669,5 @@
   } else {
     delete TPS[n];
-    LOG(0, "Node " << *((InsertUnique.first)->second->node) << " is already present in PointsOnBoundary.");
+    LOG(4, "DEBUG: Node " << *((InsertUnique.first)->second->node) << " is already present in PointsOnBoundary.");
     TPS[n] = (InsertUnique.first)->second;
   }
@@ -682,5 +682,5 @@
 void Tesselation::SetTesselationPoint(TesselPoint* Candidate, const int n) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   PointMap::const_iterator FindPoint = PointsOnBoundary.find(Candidate->getNr());
   if (FindPoint != PointsOnBoundary.end())
@@ -706,5 +706,5 @@
   BoundaryLineSet *WinningLine = NULL;
   if (FindLine != a->lines.end()) {
-    LOG(1, "INFO: There is at least one line between " << *a << " and " << *b << ": " << *(FindLine->second) << ".");
+    LOG(3, "DEBUG: There is at least one line between " << *a << " and " << *b << ": " << *(FindLine->second) << ".");
 
     pair<LineMap::iterator, LineMap::iterator> FindPair;
@@ -712,21 +712,21 @@
 
     for (FindLine = FindPair.first; (FindLine != FindPair.second) && (insertNewLine); FindLine++) {
-      LOG(1, "INFO: Checking line " << *(FindLine->second) << " ...");
+      LOG(3, "DEBUG: Checking line " << *(FindLine->second) << " ...");
       // If there is a line with less than two attached triangles, we don't need a new line.
       if (FindLine->second->triangles.size() == 1) {
         CandidateMap::iterator Finder = OpenLines.find(FindLine->second);
         if (!Finder->second->pointlist.empty())
-          LOG(1, "INFO: line " << *(FindLine->second) << " is open with candidate " << **(Finder->second->pointlist.begin()) << ".");
+          LOG(4, "DEBUG: line " << *(FindLine->second) << " is open with candidate " << **(Finder->second->pointlist.begin()) << ".");
         else
-          LOG(1, "INFO: line " << *(FindLine->second) << " is open with no candidate.");
+          LOG(4, "DEBUG: line " << *(FindLine->second) << " is open with no candidate.");
         // get open line
         for (TesselPointList::const_iterator CandidateChecker = Finder->second->pointlist.begin(); CandidateChecker != Finder->second->pointlist.end(); ++CandidateChecker) {
           if ((*(CandidateChecker) == candidate->node) && (OptCenter == NULL || OptCenter->DistanceSquared(Finder->second->OptCenter) < MYEPSILON )) { // stop searching if candidate matches
-            LOG(1, "ACCEPT: Candidate " << *(*CandidateChecker) << " has the right center " << Finder->second->OptCenter << ".");
+            LOG(4, "ACCEPT: Candidate " << *(*CandidateChecker) << " has the right center " << Finder->second->OptCenter << ".");
             insertNewLine = false;
             WinningLine = FindLine->second;
             break;
           } else {
-            LOG(1, "REJECT: Candidate " << *(*CandidateChecker) << "'s center " << Finder->second->OptCenter << " does not match desired on " << *OptCenter << ".");
+            LOG(5, "REJECT: Candidate " << *(*CandidateChecker) << "'s center " << Finder->second->OptCenter << " does not match desired on " << *OptCenter << ".");
           }
         }
@@ -753,6 +753,6 @@
 void Tesselation::AddNewTesselationTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n)
 {
-  Info FunctionInfo(__func__);
-  LOG(0, "Adding open line [" << LinesOnBoundaryCount << "|" << *(a->node) << " and " << *(b->node) << ".");
+  //Info FunctionInfo(__func__);
+  LOG(2, "DEBUG: Adding open line [" << LinesOnBoundaryCount << "|" << *(a->node) << " and " << *(b->node) << ".");
   BPS[0] = a;
   BPS[1] = b;
@@ -775,6 +775,6 @@
 void Tesselation::AddExistingTesselationTriangleLine(class BoundaryLineSet *Line, int n)
 {
-  Info FunctionInfo(__func__);
-  LOG(0, "Using existing line " << *Line);
+  //Info FunctionInfo(__func__);
+  LOG(5, "DEBUG: Using existing line " << *Line);
 
   // set endpoints and line
@@ -785,5 +785,5 @@
   CandidateMap::iterator CandidateLine = OpenLines.find(BLS[n]);
   if (CandidateLine != OpenLines.end()) {
-    LOG(1, " Removing line from OpenLines.");
+    LOG(6, "DEBUG: Removing line from OpenLines.");
     delete (CandidateLine->second);
     OpenLines.erase(CandidateLine);
@@ -799,6 +799,6 @@
 void Tesselation::AddTesselationTriangle()
 {
-  Info FunctionInfo(__func__);
-  LOG(1, "Adding triangle to global TrianglesOnBoundary map.");
+  //Info FunctionInfo(__func__);
+  LOG(4, "DEBUG: Adding triangle to global TrianglesOnBoundary map.");
 
   // add triangle to global map
@@ -819,6 +819,6 @@
 void Tesselation::AddTesselationTriangle(const int nr)
 {
-  Info FunctionInfo(__func__);
-  LOG(0, "Adding triangle to global TrianglesOnBoundary map.");
+  //Info FunctionInfo(__func__);
+  LOG(4, "DEBUG: Adding triangle to global TrianglesOnBoundary map.");
 
   // add triangle to global map
@@ -839,13 +839,13 @@
 void Tesselation::RemoveTesselationTriangle(class BoundaryTriangleSet *triangle)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   if (triangle == NULL)
     return;
   for (int i = 0; i < 3; i++) {
     if (triangle->lines[i] != NULL) {
-      LOG(0, "Removing triangle Nr." << triangle->Nr << " in line " << *triangle->lines[i] << ".");
+      LOG(4, "DEBUG: Removing triangle Nr." << triangle->Nr << " in line " << *triangle->lines[i] << ".");
       triangle->lines[i]->triangles.erase(triangle->Nr);
       std::stringstream output;
-      output << "INFO: " << *triangle->lines[i] << " is ";
+      output << *triangle->lines[i] << " is ";
       if (triangle->lines[i]->triangles.empty()) {
         output << "no more attached to any triangle, erasing.";
@@ -857,5 +857,5 @@
           output << "\t[" << (TriangleRunner->second)->Nr << "|" << *((TriangleRunner->second)->endpoints[0]) << ", " << *((TriangleRunner->second)->endpoints[1]) << ", " << *((TriangleRunner->second)->endpoints[2]) << "] \t";
       }
-      LOG(1, output.str());
+      LOG(3, "DEBUG: " << output.str());
       triangle->lines[i] = NULL; // free'd or not: disconnect
     } else
@@ -864,5 +864,5 @@
 
   if (TrianglesOnBoundary.erase(triangle->Nr))
-    LOG(0, "Removing triangle Nr. " << triangle->Nr << ".");
+    LOG(3, "DEBUG: Removing triangle Nr. " << triangle->Nr << ".");
   delete (triangle);
 }
@@ -875,5 +875,5 @@
 void Tesselation::RemoveTesselationLine(class BoundaryLineSet *line)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   int Numbers[2];
 
@@ -896,5 +896,5 @@
         for (LineMap::iterator Runner = erasor.first; Runner != erasor.second; Runner++)
           if ((*Runner).second == line) {
-            LOG(0, "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << ".");
+            LOG(4, "DEBUG: Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << ".");
             line->endpoints[i]->lines.erase(Runner);
             break;
@@ -902,19 +902,19 @@
       } else { // there's just a single line left
         if (line->endpoints[i]->lines.erase(line->Nr))
-          LOG(0, "Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << ".");
+          LOG(4, "DEBUG: Removing Line Nr. " << line->Nr << " in boundary point " << *line->endpoints[i] << ".");
       }
       if (line->endpoints[i]->lines.empty()) {
-        LOG(0, *line->endpoints[i] << " has no more lines it's attached to, erasing.");
+        LOG(4, "DEBUG: " << *line->endpoints[i] << " has no more lines it's attached to, erasing.");
         RemoveTesselationPoint(line->endpoints[i]);
       } else if (DoLog(0)) {
         std::stringstream output;
-        output << *line->endpoints[i] << " has still lines it's attached to: ";
+        output << "DEBUG: " << *line->endpoints[i] << " has still lines it's attached to: ";
         for (LineMap::iterator LineRunner = line->endpoints[i]->lines.begin(); LineRunner != line->endpoints[i]->lines.end(); LineRunner++)
           output << "[" << *(LineRunner->second) << "] \t";
-        LOG(0, output.str());
+        LOG(4, output.str());
       }
       line->endpoints[i] = NULL; // free'd or not: disconnect
     } else
-      ELOG(1, "Endpoint " << i << " has already been free'd.");
+      ELOG(4, "DEBUG: Endpoint " << i << " has already been free'd.");
   }
   if (!line->triangles.empty())
@@ -922,5 +922,5 @@
 
   if (LinesOnBoundary.erase(line->Nr))
-    LOG(0, "Removing line Nr. " << line->Nr << ".");
+    LOG(4, "DEBUG: Removing line Nr. " << line->Nr << ".");
   delete (line);
 }
@@ -934,9 +934,9 @@
 void Tesselation::RemoveTesselationPoint(class BoundaryPointSet *point)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   if (point == NULL)
     return;
   if (PointsOnBoundary.erase(point->Nr))
-    LOG(0, "Removing point Nr. " << point->Nr << ".");
+    LOG(4, "DEBUG: Removing point Nr. " << point->Nr << ".");
   delete (point);
 }
@@ -953,16 +953,16 @@
 bool Tesselation::CheckDegeneracy(CandidateForTesselation &CandidateLine, const double RADIUS, const LinkedCell_deprecated *LC) const
 {
-  Info FunctionInfo(__func__);
-
-  LOG(1, "INFO: Checking whether sphere contains no others points ...");
+  //Info FunctionInfo(__func__);
+
+  LOG(3, "DEBUG: Checking whether sphere contains no others points ...");
   bool flag = true;
 
-  LOG(1, "Check by: draw sphere {" << CandidateLine.OtherOptCenter[0] << " " << CandidateLine.OtherOptCenter[1] << " " << CandidateLine.OtherOptCenter[2] << "} radius " << RADIUS << " resolution 30");
+  LOG(3, "DEBUG: Check by: draw sphere {" << CandidateLine.OtherOptCenter[0] << " " << CandidateLine.OtherOptCenter[1] << " " << CandidateLine.OtherOptCenter[2] << "} radius " << RADIUS << " resolution 30");
   // get all points inside the sphere
   TesselPointList *ListofPoints = LC->GetPointsInsideSphere(RADIUS, &CandidateLine.OtherOptCenter);
 
-  LOG(1, "The following atoms are inside sphere at " << CandidateLine.OtherOptCenter << ":");
+  LOG(3, "DEBUG: The following atoms are inside sphere at " << CandidateLine.OtherOptCenter << ":");
   for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
-    LOG(1, "  " << *(*Runner) << " with distance " << (*Runner)->distance(CandidateLine.OtherOptCenter) << ".");
+    LOG(3, "DEBUG:   " << *(*Runner) << " with distance " << (*Runner)->distance(CandidateLine.OtherOptCenter) << ".");
 
   // remove triangles's endpoints
@@ -976,9 +976,9 @@
   // check for other points
   if (!ListofPoints->empty()) {
-    LOG(1, "CheckDegeneracy: There are still " << ListofPoints->size() << " points inside the sphere.");
+    LOG(3, "DEBUG: CheckDegeneracy: There are still " << ListofPoints->size() << " points inside the sphere.");
     flag = false;
-    LOG(1, "External atoms inside of sphere at " << CandidateLine.OtherOptCenter << ":");
+    LOG(3, "DEBUG: External atoms inside of sphere at " << CandidateLine.OtherOptCenter << ":");
     for (TesselPointList::const_iterator Runner = ListofPoints->begin(); Runner != ListofPoints->end(); ++Runner)
-      LOG(1, "  " << *(*Runner) << " with distance " << (*Runner)->distance(CandidateLine.OtherOptCenter) << ".");
+      LOG(3, "DEBUG:   " << *(*Runner) << " with distance " << (*Runner)->distance(CandidateLine.OtherOptCenter) << ".");
   }
   delete (ListofPoints);
@@ -999,5 +999,5 @@
 int Tesselation::CheckPresenceOfTriangle(TesselPoint *Candidates[3]) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   int adjacentTriangleCount = 0;
   class BoundaryPointSet *Points[3];
@@ -1021,5 +1021,5 @@
           for (; (FindLine != Points[i]->lines.end()) && (FindLine->first == Points[j]->node->getNr()); FindLine++) {
             TriangleMap *triangles = &FindLine->second->triangles;
-            LOG(1, "Current line is " << FindLine->first << ": " << *(FindLine->second) << " with triangles " << triangles << ".");
+            LOG(5, "DEBUG: Current line is " << FindLine->first << ": " << *(FindLine->second) << " with triangles " << triangles << ".");
             for (TriangleMap::const_iterator FindTriangle = triangles->begin(); FindTriangle != triangles->end(); FindTriangle++) {
               if (FindTriangle->second->IsPresentTupel(Points)) {
@@ -1027,8 +1027,7 @@
               }
             }
-            LOG(1, "end.");
           }
           // Only one of the triangle lines must be considered for the triangle count.
-          //LOG(0, "Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
+          //LOG(5, "DEBUG: Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
           //return adjacentTriangleCount;
         }
@@ -1037,5 +1036,5 @@
   }
 
-  LOG(0, "Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
+  LOG(3, "DEBUG: Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
   return adjacentTriangleCount;
 }
@@ -1052,5 +1051,5 @@
 class BoundaryTriangleSet * Tesselation::GetPresentTriangle(TesselPoint *Candidates[3])
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   class BoundaryTriangleSet *triangle = NULL;
   class BoundaryPointSet *Points[3];
@@ -1082,5 +1081,5 @@
           }
           // Only one of the triangle lines must be considered for the triangle count.
-          //LOG(0, "Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
+          //LOG(5, "DEBUG: Found " << adjacentTriangleCount << " adjacent triangles for the point set.");
           //return adjacentTriangleCount;
         }
@@ -1104,5 +1103,5 @@
 bool Tesselation::FindStartingTriangle(const double RADIUS, const LinkedCell_deprecated *LC)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   int i = 0;
   TesselPoint* MaxPoint[NDIM];
@@ -1136,5 +1135,5 @@
           for (TesselPointSTLList::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
             if ((*Runner)->at(map[0]) > maxCoordinate[map[0]]) {
-              LOG(1, "New maximal for axis " << map[0] << " node is " << *(*Runner) << " at " << (*Runner)->getPosition() << ".");
+              LOG(4, "DEBUG: New maximal for axis " << map[0] << " node is " << *(*Runner) << " at " << (*Runner)->getPosition() << ".");
               maxCoordinate[map[0]] = (*Runner)->at(map[0]);
               MaxPoint[map[0]] = (*Runner);
@@ -1152,5 +1151,5 @@
     for (int i = 0; i < NDIM; i++)
       output << i << ": " << *MaxPoint[i] << "\t";
-    LOG(1, output.str());
+    LOG(3, "DEBUG: " << output.str());
   }
 
@@ -1161,5 +1160,5 @@
     BaseLine = new BoundaryLineSet();
     BaseLine->endpoints[0] = new BoundaryPointSet(MaxPoint[k]);
-    LOG(0, "INFO: Coordinates of start node at " << *BaseLine->endpoints[0]->node << ".");
+    LOG(2, "DEBUG: Coordinates of start node at " << *BaseLine->endpoints[0]->node << ".");
 
     double ShortestAngle;
@@ -1206,13 +1205,14 @@
 
     // adding point 1 and point 2 and add the line between them
-    LOG(0, "Coordinates of start node at " << *BaseLine->endpoints[0]->node << ".");
-    LOG(0, "Found second point is at " << *BaseLine->endpoints[1]->node << ".");
+    LOG(2, "DEBUG: Found second point is at " << *BaseLine->endpoints[1]->node << ".");
 
     //LOG(1, "INFO: OldSphereCenter is at " << helper << ".");
     CandidateForTesselation OptCandidates(BaseLine);
     FindThirdPointForTesselation(NormalVector, SearchDirection, SphereCenter, OptCandidates, NULL, RADIUS, LC);
-    LOG(0, "List of third Points is:");
-    for (TesselPointList::iterator it = OptCandidates.pointlist.begin(); it != OptCandidates.pointlist.end(); it++) {
-      LOG(0, " " << *(*it));
+    {
+      std::stringstream output;
+      for (TesselPointList::iterator it = OptCandidates.pointlist.begin(); it != OptCandidates.pointlist.end(); it++)
+        output << *(*it);
+      LOG(2, "DEBUG: List of third Points is: " << output.str());
     }
     if (!OptCandidates.pointlist.empty()) {
@@ -1248,5 +1248,5 @@
 //bool Tesselation::HasOtherBaselineBetterCandidate(CandidateForTesselation &CandidateLine, const TesselPoint * const ThirdNode, double RADIUS, const LinkedCell_deprecated * const LC) const
 //{
-//	Info FunctionInfo(__func__);
+//	//Info FunctionInfo(__func__);
 //  bool result = false;
 //  Vector CircleCenter;
@@ -1387,5 +1387,5 @@
 bool Tesselation::FindNextSuitableTriangle(CandidateForTesselation &CandidateLine, const BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell_deprecated *LC)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   Vector CircleCenter;
   Vector CirclePlaneNormal;
@@ -1402,5 +1402,5 @@
       break;
     }
-  LOG(0, "Current baseline is " << *CandidateLine.BaseLine << " with ThirdPoint " << *ThirdPoint << " of triangle " << T << ".");
+  LOG(3, "DEBUG: Current baseline is " << *CandidateLine.BaseLine << " with ThirdPoint " << *ThirdPoint << " of triangle " << T << ".");
 
   CandidateLine.T = &T;
@@ -1422,7 +1422,7 @@
     CircleRadius = RADIUS * RADIUS - radius / 4.;
     CirclePlaneNormal.Normalize();
-    LOG(1, "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << ".");
-
-    LOG(1, "INFO: OldSphereCenter is at " << T.SphereCenter << ".");
+    LOG(3, "DEBUG: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << ".");
+
+    LOG(3, "DEBUG: OldSphereCenter is at " << T.SphereCenter << ".");
 
     // construct SearchDirection and an "outward pointer"
@@ -1431,8 +1431,8 @@
     if (helper.ScalarProduct(SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
       SearchDirection.Scale(-1.);
-    LOG(1, "INFO: SearchDirection is " << SearchDirection << ".");
+    LOG(3, "DEBUG: SearchDirection is " << SearchDirection << ".");
     if (fabs(RelativeSphereCenter.ScalarProduct(SearchDirection)) > HULLEPSILON) {
       // rotated the wrong way!
-      ELOG(1, "SearchDirection and RelativeOldSphereCenter are still not orthogonal!");
+      ELOG(3, "DEBUG: SearchDirection and RelativeOldSphereCenter are still not orthogonal!");
     }
 
